# Customizing Generated LookML Files

### **Model level customizations**

**For models, i**nsert the **meta key** and overriding value in the **models** section of the YML file.

The **tags key, under config** is used to add instructions for skipping the sync of a model.

for example:

```
models:
  - name: dbt_model_name_1
    meta:
        euno.ai/lookml_view_name: "new_view_name"
  - name: dbt_model_name_2
        config:
             tags: ["euno.ai/skip_lookml_sync"]
```

<table data-full-width="true"><thead><tr><th width="198">Sync customization</th><th width="250">Description</th><th width="208">Default</th><th>Example</th></tr></thead><tbody><tr><td>euno.ai/skip_lookml_sync</td><td><p><strong>Add under models: config: tags</strong></p><p>add this to the list of <strong>tags</strong> to skip syncing the model</p></td><td>Sync model</td><td>["euno.ai/skip_lookml_sync"]<br></td></tr><tr><td>euno.ai/lookml_filename</td><td><strong>Add under models: meta</strong><br>Full path of the resulting view file<br><br><strong>Note</strong>: This will override lookml_directory, lookml_filename_prefix, and lookml_filename_suffix</td><td>./&#x3C;model name>.view.lkml (The filepath needs to include the suffix for the file format)</td><td>euno.ai/lookml_filename: "new_view_filename.view.lkml"</td></tr><tr><td>euno.ai/lookml_directory</td><td><strong>Add under models: meta</strong><br>Adds the file to a sub-directory within the directory configured in the data application sync setup (see <a href="#jn4haok8b508">configuring target repository</a>)</td><td>No sub-directory by default</td><td>euno.ai/lookml_directory: "new_subdirectory"</td></tr><tr><td>euno.ai/lookml_filename_prefix</td><td><strong>Add under models: meta</strong><br>Adds a prefix to the view's file name (e.g. prefix_model-name.view.lkml)<br><br><strong>Note:</strong> This can be used in tandem with euno.ai/lookml_filename_suffix and euno.ai/lookml_directory, but not euno.ai/lookml_filename, which will override this value.</td><td>No filename prefix by default</td><td>euno.ai/lookml_filename_prefix: "filename_prefix_"</td></tr><tr><td>euno.ai/lookml_filename_suffix</td><td><strong>Add under models: meta</strong><br>Adds a suffix to the view's file name (e.g. model-name_suffix.view.lkml)<br><br><strong>Note:</strong> This can be used in tandem with euno.ai/lookml_filename_prefix and euno.ai/lookml_directory, but not euno.ai/lookml_filename, which will override this value.</td><td>No filename suffix by default</td><td>euno.ai/lookml_filename_suffix: "_filename_suffix"</td></tr><tr><td>euno.ai/lookml_sql_table_schema</td><td><p><strong>Add under models: meta</strong><br>Overrides only the schema part of <em>sql_table_name</em> property<br>keeps the table name specified in the manifest file</p><p><strong>Note:</strong> will override euno.ai/lookml_sql_table_name<br><a href="https://cloud.google.com/looker/docs/reference/param-view-sql-table-name">LookML reference</a></p></td><td>schema and table names specified in the manifest file</td><td>euno.ai/lookml_sql_table_schema: "other_schema"</td></tr><tr><td>euno.ai/lookml_sql_table_name</td><td><strong>Add under models: meta</strong><br>Overrides <em>sql_table_name</em> property in LookML<br><a href="https://cloud.google.com/looker/docs/reference/param-view-sql-table-name">LookML reference</a></td><td>schema and table names specified in the manifest file</td><td>euno.ai/lookml_sql_table_name: "other_schema.other_table"</td></tr><tr><td>euno.ai/lookml_view_name</td><td><strong>Add under models: meta</strong><br>Name of the view</td><td>Model name</td><td>euno.ai/lookml_view_name: "new_view_name"</td></tr><tr><td>euno.ai/lookml_view_name_prefix</td><td><strong>Add under models: meta</strong><br>Adds a prefix to the default view name (e.g. prefix_model-name)<br><br><strong>Note:</strong> This can be used in tandem with euno.ai/lookml_view_name_suffix, but not euno.ai/lookml_view_name, which will override this value.</td><td>No view name prefix by default</td><td>euno.ai/lookml_view_name_prefix: "view_name_prefix_"</td></tr><tr><td>euno.ai/lookml_view_name_suffix</td><td><strong>Add under models: meta</strong><br>Adds a suffix to the default view name (e.g. model-name_suffix)<br><br><strong>Note:</strong> This can be used in tandem with euno.ai/lookml_view_name_prefix, but not euno.ai/lookml_view_name, which will override this value.</td><td>No view name suffix by default</td><td>euno.ai/lookml_view_name_suffix: "view_name_suffix_"</td></tr><tr><td>euno.ai/lookml_sync_timeframes</td><td><strong>Add under models: meta</strong><br>Only relevant for time dimensions. Overrides <strong>ALL</strong> the default timeframes within the view for a timestamp or date column. This is a comma separated list of time grains.<br><br><strong>Note:</strong> If this key is used at both the model and column level, the more specific option, the column, will override.</td><td>raw, time, hour_of_day, date, day_of_week, week, month, quarter, year</td><td></td></tr><tr><td>euno.ai/lookml_sync_convert_tz</td><td><strong>Add under models: meta</strong><br>Only relevant for time dimensions. Overrides the default for converting by timezone in <strong>ALL</strong> the time and date dimensions in the view.<br><br><strong>Note:</strong> If this key is used at both the model and column level, the more specific option, the column, will override.<br><a href="https://cloud.google.com/looker/docs/reference/param-field-convert-tz">LookML reference</a></td><td>The default is set to yes.</td><td>euno.ai/lookml_sync_convert_tz: "no"</td></tr></tbody></table>

### Generating Explores

This section is only applicable if the job is configured to generate explores. Below is a table listing the relevant directives for generating explores:

<table data-full-width="true"><thead><tr><th>Directive</th><th>Description</th><th>Default</th><th>Example</th></tr></thead><tbody><tr><td>euno.ai/lookml_explore_filename</td><td>Defines the full path of the resulting explore file. Overrides any path prefix/suffix settings.</td><td><code>./&#x3C;model name>.explore.lkml</code></td><td><code>euno.ai/lookml_explore_filename: "new_explore_filename.explore.lkml"</code></td></tr><tr><td>euno.ai/lookml_explore_filename_prefix</td><td>Adds a prefix to the explore's file name.</td><td>No prefix by default</td><td><code>euno.ai/lookml_explore_filename_prefix: "explore_prefix_"</code></td></tr><tr><td>euno.ai/lookml_explore_filename_suffix</td><td>Adds a suffix to the explore's file name.</td><td>No suffix by default</td><td><code>euno.ai/lookml_explore_filename_suffix: "_explore_suffix"</code></td></tr><tr><td>euno.ai/lookml_sql_table_name</td><td>Overrides the <code>sql_table_name</code> property specifically for explore configurations.</td><td>As specified in manifest</td><td><code>euno.ai/lookml_sql_table_name: "custom_schema.custom_explore_table"</code></td></tr></tbody></table>

### **dbt column / dbt metric level customizations**

By default, Euno will generate a single dimension clause for each column and a single measure for each dbt metric (MetricFlow).

**Please note that only simple metrics and ratios are currently supported for dbt Metrics. In addition, we do not support metrics across multiple dbt models.**

**For columns,** insert the **meta key** and overriding value underneath the column in the **columns** section in the dbt **models** definition in the YML file.

**For metrics, i**nsert the **config key** and overriding value in the **semantic models metrics** section of the YML file.

The **tags key** is used to add instructions for skipping the sync of a column/metric.

examples:

**Add sync customization to a dbt column definition:**

```
models:
...
  columns:
    - name: dbt_model_column_name_1
       meta: 
            euno.ai/lookml_label: "some_lookml_label"
   - name: dbt_model_column_name_2
       tags: 
            ["euno.ai/skip_lookml_sync"]
```

**Add sync customization to a metric:**

```
semantic models:
...
  metrics:
    - name: dbt_metric_name_1
       config:
            euno.ai/lookml_label: "some_lookml_label"
    - name: dbt_metric_name_2
       tags: 
            ["euno.ai/skip_lookml_sync"]
```

<table data-full-width="true"><thead><tr><th width="142">Sync customization</th><th width="284">Description</th><th width="204">Default</th><th>Example</th></tr></thead><tbody><tr><td>euno.ai/skip_lookml_sync</td><td><p><strong>Add unde</strong>r <strong>columns: tags / metrics: tags</strong></p><p>Add this to the list of <strong>tags</strong> to skip this column/metric</p></td><td>The column/metric is included in the sync</td><td>tags: ["euno.ai/skip_lookml_sync"]</td></tr><tr><td>euno.ai/lookml_label</td><td><p><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong></p><p>Overrides LookML label for the field<br><a href="https://cloud.google.com/looker/docs/reference/param-field-label">LookML reference</a></p></td><td>No label</td><td>euno.ai/lookml_label: "some_lookml_label"<br></td></tr><tr><td>euno.ai/lookml_view_label</td><td><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong><br>Overrides the LookML view under which the field is listed in the field picker<br><a href="https://cloud.google.com/looker/docs/reference/param-field-view-label">LookML reference</a></td><td>No label</td><td>euno.ai/lookml_view_label: "some_lookml_view_name"</td></tr><tr><td>euno.ai/lookml_group_label</td><td><p><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong></p><p>Overrides the field in LookML group_label<br><a href="https://cloud.google.com/looker/docs/reference/param-field-group-label">LookML reference</a></p></td><td>No group label</td><td>euno.ai/lookml_group_label: "some_lookml_group_label"</td></tr><tr><td>euno.ai/lookml_hidden</td><td><p><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong></p><p>Overrides the field in LookML hidden<br><a href="https://cloud.google.com/looker/docs/reference/param-field-hidden">LookML reference</a></p></td><td>Not hidden</td><td>euno.ai/lookml_hidden: "yes"</td></tr><tr><td>euno.ai/lookml_value_format</td><td><p><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong></p><p>Overrides the field in LookML value_format<br><a href="https://cloud.google.com/looker/docs/reference/param-field-group-label?hl=en">LookML reference</a></p></td><td>No value format</td><td>euno.ai/lookml_value_format: "$#.00;($#.00)"</td></tr><tr><td>euno.ai/lookml_value_format_name</td><td><p><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong></p><p>Overrides the field in LookML value_format_name<br><a href="https://cloud.google.com/looker/docs/reference/param-field-value-format-name">LookML reference</a></p></td><td>No value format name</td><td>euno.ai/lookml_value_format_name: "usd"</td></tr><tr><td>euno.ai/lookml_extra</td><td><p><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong></p><p>For this specific key we expect users to insert a string with a LookML parameter to be placed under the dimension or measure. For example "can_filter: yes"<br><a href="https://cloud.google.com/looker/docs/reference/param-field">LookML reference</a></p></td><td>No extra parameters</td><td>euno.ai/lookml_extra: "can_filter: yes"</td></tr><tr><td>euno.ai/lookml_tags</td><td><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong><br>Overrides fields tags in the LookMLml file<br><a href="https://cloud.google.com/looker/docs/reference/param-field-tags">LookML reference</a></td><td>No override</td><td>euno.ai/lookml_tags: ["tag1", "tag2"]</td></tr><tr><td>euno.ai/lookml_sync_sql</td><td><strong>Add unde</strong>r <strong>columns: meta / metrics: config</strong><br>Overrides the sql used for this LookML dimension, or measure<br>LookML reference</td><td><p>For dimension - ${TABLE}.&#x3C;column name><br>For measure:</p><ul><li>Simple - "expr" attribute of underlying measure in dbt</li><li>Ratio - ${measure}/${measure}</li></ul></td><td>euno.ai/lookml_sync_sql: "${TABLE}.total/100"</td></tr><tr><td>euno.ai/lookml_sync_dimension_name</td><td><p><strong>Relevant for columns only</strong></p><p><strong>Add under</strong> <strong>columns: meta</strong></p><p>Overrides the name of the LookML dimension</p></td><td>Column name used by default</td><td>euno.ai/lookml_sync_dimension_name: "new_dimension_name"</td></tr><tr><td>euno.ai/lookml_sync_measure_name</td><td><p><strong>Relevant for metrics only</strong></p><p><strong>Add under</strong> <strong>metrics: config</strong></p><p>Overrides the name of the LookML measure</p></td><td>Metric named used by default</td><td>euno.ai/lookml_sync_dimension_name: "new_measure_name"</td></tr><tr><td>euno.ai/lookml_primary_key</td><td><p><strong>Relevant for columns only</strong></p><p><strong>Add under columns: meta</strong></p><p>Overrides the primary key parameter of the dimension<br><a href="https://cloud.google.com/looker/docs/reference/param-field-primary-key">LookML reference</a></p></td><td>No override of primary key parameter</td><td>euno.ai/lookml_primary_key: "yes"</td></tr><tr><td>euno.ai/lookml_sync_timeframes</td><td><p><strong>Relevant for columns only</strong></p><p><strong>Add under</strong> <strong>columns: meta</strong></p><p>Only relevant for a timestamp or date column. Overrides the default dimension_group timeframes. This is a comma separated list of time grains.<br><a href="https://cloud.google.com/looker/docs/reference/param-field-dimension-group#type_time">LookML reference</a></p></td><td>dimension_group of type time with raw, time, hour_of_day, date, day_of_week, week, month, quarter, year</td><td>euno.ai/lookml_sync_timeframes: ["raw", "time", "hour_of_day", "date", "week"]</td></tr><tr><td>euno.ai/lookml_sync_convert_tz</td><td><p><strong>Relevant for columns only</strong></p><p><strong>Add under</strong> <strong>columns: meta</strong></p><p>Only relevant for a timestamp or date column. Overrides the default for converting by timezone.<br><a href="https://cloud.google.com/looker/docs/reference/param-field-dimension-group#time_zone_conversions_and_convert_tz">LookML reference</a></p></td><td>The default is set to yes.</td><td>euno.ai/lookml_sync_convert_tz: "no"</td></tr><tr><td>euno.ai/lookml_filters</td><td><p><strong>Relevant for metrics only</strong></p><p><strong>Add under</strong> <strong>metrics: config</strong><br>Adds filters to the LookML measure.<br><a href="https://cloud.google.com/looker/docs/reference/param-field-filters">LookML reference</a></p></td><td>No filters</td><td>euno.ai/lookml_filters: [dimension_name: "filter expression", dimension_name: "filter expression"]</td></tr><tr><td>euno.ai/analytical_semantic_role</td><td><p><strong>Relevant for columns only</strong></p><p><strong>Add under</strong> <strong>columns: meta</strong><br>Adding this key with the value "measure" overrides the sync's default semantic role and syncs a column to a LookML measure.<br></p><p>Unless stated otherwise, the LookML measure type will default to sum. Adding the following key: <strong>euno.ai/default_aggregation_override</strong> with the desired aggregation as value (e.g., "sum", "average", "count_distinct", etc.) will override the aggregation type.</p></td><td>By default, a dbt column syncs to a LookML dimension</td><td>euno.ai/analytical_semantic_role: "measure"<br>euno.ai/default_aggregation_override: "average"</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.euno.ai/using-euno/metadata-activation/data-application-sync/customizing-generated-lookml-files.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
